package cn.ecpark.service.usergw.biz.filters;

import java.nio.ByteBuffer;
import java.util.Map;


import org.apache.dubbo.config.ApplicationConfig;
import org.apache.dubbo.config.ProtocolConfig;
import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.config.RegistryConfig;
import org.apache.dubbo.config.utils.ReferenceConfigCache;
import org.apache.dubbo.rpc.service.GenericService;
import org.springframework.cloud.gateway.filter.GatewayFilterChain;
import org.springframework.cloud.gateway.filter.GlobalFilter;
import org.springframework.core.Ordered;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.stereotype.Component;
import org.springframework.web.server.ServerWebExchange;
import com.alibaba.fastjson.*;

import reactor.core.publisher.Mono;







@Component
public class DubboFilter implements GlobalFilter, Ordered {

    @Override
    public int getOrder() {
        return Ordered.LOWEST_PRECEDENCE;
    }

    @Override
    public Mono<Void> filter(ServerWebExchange exchange, GatewayFilterChain chain) {
        exchange.getRequest();
        ReferenceConfig<GenericService> reference = new
        ReferenceConfig<GenericService>(); // 该实例很重量，里面封装了所有与注册中心及服务提供方连接，请缓存

        reference.setApplication(new ApplicationConfig("dubbo-exchange"));
        // reference.setRegistry(new RegistryConfig("zookeeper://127.0.0.1:2181"));
        reference.setInterface("ocean.demo.api.IExchange"); // 弱类型接口名
        reference.setVersion("1.0.0");
        reference.setGeneric(true); // 声明为泛化接口

        ReferenceConfigCache cache = ReferenceConfigCache.getCache();
        GenericService gs = cache.get(reference);
        



        Object result = gs.$invoke("Hello", new String[]{}, new Object[]{});
        if (result != null) {
            ServerHttpResponse response = exchange.getResponse();
            return response.writeWith( Mono.just(response.bufferFactory().wrap(ByteBuffer.wrap(JSON.toJSONString(result).getBytes()))));
        }
        return chain.filter(exchange);
    }
    
}